# the explicit requires remove a deprecation warning in Rails 6
# https://stackoverflow.com/questions/56402093/how-can-i-preload-concerns-in-a-rails-initializer-using-rails-6-zeitwerk
require "ucb_rails_user/configuration/email"
require "ucb_rails_user/configuration/ldap"
require "ucb_rails_user/configuration/cas"

############################################################
# Load configuration from config/credentials.yml.enc
############################################################

credentials = Rails.application.credentials

############################################################
# ActionMailer
############################################################

# don't send real emails in development or test
unless Rails.env.test? || Rails.env.development?
  UcbRailsUser::Configuration::Email.configure(credentials.email&.with_indifferent_access())
end

############################################################
# Exception Notification
############################################################

#UcbRails::Configuration::ExceptionNotification.configure(config.for('exception_notification'))

############################################################
# UCB::LDAP
############################################################

UcbRailsUser::Configuration::Ldap.configure(credentials.ldap&.with_indifferent_access())

############################################################
# OmniAuth
############################################################

UcbRailsUser::Configuration::Cas.configure(credentials.cas&.with_indifferent_access())

############################################################
# UcbRails
############################################################

UcbRailsUser.config do |config|

  #########################################################
  # manage login authorization, current user, etc.
  #########################################################

  # config.user_session_manager = "UcbRailsUser::UserSessionManager::InPeopleOu"
  # KEEP THIS NEXT ONE
  config.user_session_manager = "UcbRailsUser::UserSessionManager::InPeopleOuAddToUsersTable"
  # config.user_session_manager = "UcbRailsUser::UserSessionManager::ActiveInUserTable"
  # config.user_session_manager = "UcbRailsUser::UserSessionManager::AdminInUserTable"

  #########################################################
  # omniauth authentication provider
  #########################################################

  config.omniauth_provider = :cas        # goes to CalNet
  # config.omniauth_provider = :developer  # Users test ldap entries

end
